﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace CG.EventXmlDeserialization
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("CG.EventXmlDeserialization");
            Console.WriteLine("Illustrates deserializing xml into an object\n");
            
            // Simulate incoming xml string by reading the xml file
            // and convert it into and xml string
            var xmlDoc = new XmlDocument();
            xmlDoc.Load("event.xml");
            var xml = xmlDoc.InnerXml;

            // Deserialize the xml into an Event object
            var evt = Event.CreateFromXml(xml);

            // Use the Event object's values
            Console.WriteLine("{0,15} {1}", "EventId:", evt.EventId);
            Console.WriteLine("{0,15} {1}", "Site:", evt.Site);

            Console.WriteLine("\n{0,15}", "Currencies:");
            foreach (var currency in evt.Data.Currencies)
            {
                Console.WriteLine("{0,20} {1}", "IsoCode:", currency.IsoCode);
                Console.WriteLine("{0,20} {1}", "BankBuyRate:", currency.BankBuyRate);
                Console.WriteLine("{0,20} {1}", "BankSellRate:", currency.BankSellRate);
                Console.WriteLine("{0,20} {1}", "StaffBuyRate:", currency.StaffBuyRate);
                Console.WriteLine("{0,20} {1}", "StaffSellRate:", currency.StaffSellRate);
                Console.WriteLine("{0,20} {1}", "DisplayName:", currency.DisplayName);
                Console.WriteLine("{0,20} {1}", "DecimalDigits:", currency.DecimalDigits);
            }
        }
    }
}
